# Class DefaultCitationDate

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultCitationDate

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `CitationDate`

@TitleProperty(name="referenceDate") public class DefaultCitationDate extends ISOMetadata implements CitationDate
Reference date and event used to describe it. The following properties are mandatory in a well-formed metadata according ISO 19115:
`CI_Date` `├─date………………` Reference date for the cited resource. `└─dateType……` Event used for reference date.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultCitationDate()`
  Constructs an initially empty citation date.
  `DefaultCitationDate(Temporal date, DateType dateType)`
  Constructs a citation date initialized to the given date.
  `DefaultCitationDate(Date date, DateType dateType)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Replaced by `DefaultCitationDate(Temporal, DateType)` in order to transition to `java​.time` API.
  `DefaultCitationDate(CitationDate object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultCitationDate`
  `castOrCopy(CitationDate object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Date`
  `getDate()`
  Deprecated.
  Replaced by `getReferenceDate()`.
  `DateType`
  `getDateType()`
  Returns the event used for reference date.
  `Temporal`
  `getReferenceDate()`
  Returns the reference date for the cited resource.
  `void`
  `setDate(Date newValue)`
  Deprecated.
  Replaced by `setReferenceDate(Temporal)`.
  `void`
  `setDateType(DateType newValue)`
  Sets the event used for reference date.
  `void`
  `setReferenceDate(Temporal newValue)`
  Sets the reference date for the cited resource.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, clone, equals, equals, getInterface, hashCode, isEmpty, nilReasons, prune, toString`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultCitationDate

    public DefaultCitationDate()
    Constructs an initially empty citation date.

  - ### DefaultCitationDate

    public DefaultCitationDate(Temporal date, DateType dateType)
    Constructs a citation date initialized to the given date.
    Parameters:
      `date` - the reference date for the cited resource, or `null` if unknown.
      `dateType` - the event used for reference date, or `null` if unknown.
    Since:
      1.5

  - ### DefaultCitationDate

    @Deprecated(since="1.5", forRemoval=true) public DefaultCitationDate(Date date, DateType dateType)
    Deprecated, for removal: This API element is subject to removal in a future version.
    Replaced by `DefaultCitationDate(Temporal, DateType)` in order to transition to `java​.time` API.
    Constructs a citation date initialized to the given date.
    Parameters:
      `date` - the reference date for the cited resource.
      `dateType` - the event used for reference date.

  - ### DefaultCitationDate

    public DefaultCitationDate(CitationDate object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(CitationDate)`

- ## Method Details

  - ### castOrCopy

    public static DefaultCitationDate castOrCopy(CitationDate object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultCitationDate`, then it is returned unchanged.
    - Otherwise a new `DefaultCitationDate` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getDate

    @Deprecated(since="1.5") public Date getDate()
    Deprecated.
    Replaced by `getReferenceDate()`.
    Returns the reference date for the cited resource.
    Specified by:
      `getDate` in interface `CitationDate`
    Returns:
      reference date for the cited resource, or `null`.

  - ### setDate

    @Deprecated(since="1.5") public void setDate(Date newValue)
    Deprecated.
    Replaced by `setReferenceDate(Temporal)`.
    Sets the reference date for the cited resource.
    Parameters:
      `newValue` - the new date.

  - ### getReferenceDate

    @UML(identifier="date", obligation=MANDATORY, specification=ISO_19115) public Temporal getReferenceDate()
    Returns the reference date for the cited resource.
    Returns:
      reference date for the cited resource, or `null`.
    Since:
      1.5

  - ### setReferenceDate

    public void setReferenceDate(Temporal newValue)
    Sets the reference date for the cited resource. The specified value should be an instance of `LocalDate`, `LocalDateTime`, `OffsetDateTime` or `ZonedDateTime`, depending whether hours are defined and how the timezone (if any) is defined. But other types are also allowed. For example, a citation date may be merely a `Year`.
    Parameters:
      `newValue` - the new date.
    Since:
      1.5

  - ### getDateType

    public DateType getDateType()
    Returns the event used for reference date.
    Specified by:
      `getDateType` in interface `CitationDate`
    Returns:
      event used for reference date, or `null`.

  - ### setDateType

    public void setDateType(DateType newValue)
    Sets the event used for reference date.
    Parameters:
      `newValue` - the new event.